      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*8 (I-N)
      PARAMETER (MBAS=5000)
      DIMENSION E1(MBAS,MBAS),E2(MBAS,MBAS),
     $ E3(MBAS,MBAS),E4(MBAS,MBAS),IM(MBAS),INONZ(40) 
      CHARACTER W78*78,W10*10,A20*20,B20*20,FIANAME*9
      IL=0
      READ (*,*,ERR=30,END=30) NB,NMO,NOCC,ITYP,NNONZ
      IF (NB.GT.MBAS.OR.NMO.GT.NB.OR.NNONZ.GT.20) THEN
      WRITE (*,'(A,A)') 'Error: NB > MBAS=5000 or ',
     $ 'NMO > NB or ITYP.NE.1 or 2 or NNONZ > 20'
      GOTO 30
      ENDIF
      N=NMO
C Reading indexes for included coupling terms (if nothing is provided,
C all terms will be considered)
      IL=1
      IF (NNONZ.GT.0) THEN
      READ (*,*,ERR=30,END=30) (INONZ(K),K=1,2*NNONZ)
      ENDIF
C Reading MO coefficients
      IL=2
      IF (NB.LE.5) THEN
      DO I1=1,N
      IL=3
      READ (*,'(I2,1X,I2,5(1PE15.8))',ERR=30,END=30) 
     $ K1,K2,(E1(I2,I1),I2=1,NB)
      ENDDO
      ELSE
      N2=NB/5
      N3=N2*5
      N4=NB-N3
      DO I1=1,N
      DO I2=1,N2
      I01=(I2-1)*5+1
      I02=(I2-1)*5+5
      IL=4
      READ (*,'(I2,1X,I2,5(1PE15.8))',ERR=30,END=30) 
     $ K1,K2,(E1(J,I1),J=I01,I02)
      ENDDO
      IL=5
      IF (N4.LT.0.OR.N4.GE.5) GOTO 30
      IF (N4.NE.0) THEN
      IL=6
      I01=N3+1
      I02=NB
      READ (*,'(I2,1X,I2,5(1PE15.8))',ERR=30,END=30)
     $ K1,K2,(E1(J,I1),J=I01,I02)
      ENDIF
      ENDDO
      ENDIF
C Reading the Fock matrix
      IL=7
      READ (*,'(A78)',ERR=30,END=30) W78
      IL=8
      IF (NB.LE.5) THEN
      READ (*,'(A78)',ERR=30,END=30) W78
      IL=9
      READ (*,*,ERR=30,END=30) (IM(I2),I2=1,NB)
      IL=10
      READ (*,'(A78)',ERR=30,END=30) W78
      IL=11
      DO I2=1,NB
      READ (*,'(I5,A10,5(F11.6))',ERR=30,END=30)
     $ K1,W10,(E2(K1,IM(K2)),K2=1,NB)
      ENDDO
      ELSE
      DO I1=1,N2
c      write (*,*) I1
      IL=12
      READ (*,'(A78)',ERR=30,END=30) W78
c      write (*,*) W78
      IL=13
      READ (*,*,ERR=30,END=30) (IM(I2),I2=1,5)
      IL=14
      READ (*,'(A78)',ERR=30,END=30) W78
      IL=15
      I02=(I1-1)*5+1
      I03=0
      DO I2=I02,NB
      I03=I03+1
      IF (I03.LE.5) THEN 
      READ (*,'(I5,A10,5(F11.6))',ERR=30,END=30)
     $ K1,W10,(E2(K1,IM(K2)),K2=1,I03)
      ELSE
      IL=16
      READ (*,'(I5,A10,5(F11.6))',ERR=30,END=30)
     $ K1,W10,(E2(K1,IM(K2)),K2=1,5)
      ENDIF
      ENDDO
      ENDDO
      IF (N4.NE.0) THEN
      IL=17
      READ (*,'(A78)',ERR=30,END=30) W78
      IL=18
      READ (*,*,ERR=30,END=30) (IM(I2),I2=1,N4)
      IL=19
      READ (*,'(A78)',ERR=30,END=30) W78
      IL=20
      DO I2=1,N4
      READ (*,'(I5,A10,5(F11.6))',ERR=30,END=30)
     $ K1,W10,(E2(K1,IM(K2)),K2=1,N4)
      ENDDO
      ENDIF
      ENDIF    
      IL=21
C
C      WRITE (*,*) 'Fock matrix'
      DO I=1,NB
      DO J=1,NB
      E2(I,J)=E2(J,I)
      ENDDO
      ENDDO
      DO I=1,NB
c      WRITE (*,'(500(1X,E11.4))') (E2(I,J),J=1,NB)
      ENDDO
C
C      WRITE (*,*) 'Matrix C^T*F*C'
      DO I=1,NB
      DO J=1,N
      E3(I,J)=0
      DO K=1,NB
      E3(I,J)=E3(I,J)+E2(I,K)*E1(K,J)
      ENDDO
      ENDDO
      ENDDO
      DO I=1,N
      DO J=1,N
      E4(I,J)=0
      DO K=1,NB
      E4(I,J)=E4(I,J)+E1(K,I)*E3(K,J)
      ENDDO
      ENDDO
      ENDDO
C
      DO I=1,N
      DO J=1,N
      IF (DABS(E4(I,J)).LE.ACC) E4(I,J)=0.D0
      ENDDO
      ENDDO
C
      DO I=1,N
C      EN(I)=E4(I,I)
C      WRITE (*,'(I3,1X,F9.3)') I,EN(I)
C      WRITE (*,'(500(1X,E9.2))') (E4(I,J),J=1,N)
      ENDDO
      WRITE (FIANAME,'(A4,I5.5)') 'FIA.',NOCC
      NCONF=NOCC*(N-NOCC)
      OPEN (1,FILE=FIANAME)
      IF (NNONZ.EQ.0) THEN
      WRITE (1,'(10X,I4,5X,I1)') NCONF,ITYP
      DO I=1,NOCC
      DO J=NOCC+1,N
      IF (ITYP.EQ.1) THEN
      WRITE (1,'(E15.8,1X,2(1X,I5),1X,A,A,A)')
     $ E4(I,J),I,J,"'",'ALPHA',"'"
      ENDIF
      IF (ITYP.EQ.2) THEN
      WRITE (1,'(E15.8,1X,2(1X,I5),1X,A,A,A)')
     $ E4(I,J),I,J,"'",'BETA ',"'"
      ENDIF
      ENDDO
      ENDDO
      ELSE
       NNONZ1=NNONZ
        DO K=1,NNONZ*2,2
        I=INONZ(K)
        J=INONZ(K+1)
        IF (I.GT.NOCC.OR.J.LE.NOCC) NNONZ1=NNONZ1-1
        ENDDO
       WRITE (1,'(10X,I4,5X,I1)') NNONZ1,ITYP
        IF (NNONZ1.NE.0) THEN
         DO K=1,NNONZ*2,2
         I=INONZ(K)
         J=INONZ(K+1)
          IF (I.LE.NOCC.AND.J.GT.NOCC) THEN   
           IF (ITYP.EQ.1) THEN
           WRITE (1,'(E15.8,1X,2(1X,I5),1X,A,A,A)')
     $ E4(I,J),I,J,"'",'ALPHA',"'"
           ENDIF
           IF (ITYP.EQ.2) THEN
           WRITE (1,'(E15.8,1X,2(1X,I5),1X,A,A,A)')
     $ E4(I,J),I,J,"'",'BETA ',"'"
           ENDIF
          ENDIF
         ENDDO
        ENDIF
      ENDIF
      CLOSE (1)
      WRITE (*,'(A,A9,A,A)') 'File ',FIANAME,
     $ ' containing <Psi_0|Hcis|Psi_ia>',
     $ ' matrix elements has been created.'
C
      GOTO 40
C
30    WRITE (*,*) 'ERROR IN mntda.exe #:',IL
      STOP
40    CONTINUE
      END
